package com.example.administrator.wingcool_gt9_apk;

import android.Manifest;
import android.app.Activity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.graphics.Color;
import android.hardware.usb.UsbConstants;
import android.hardware.usb.UsbDevice;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbEndpoint;
import android.hardware.usb.UsbInterface;
import android.hardware.usb.UsbManager;
import android.hardware.usb.UsbRequest;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.GridLayout;
import android.widget.TextView;
import android.widget.Toast;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.RandomAccessFile;
import java.io.Reader;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class DataAnalysis extends AppCompatActivity
        implements   OpenDevicesReceiver.OpenDevicesListener, View.OnClickListener {
    private Context mAlertContext;
    //MainActivity mMainAct = new MainActivity();
    private byte[] mBytes = new byte[2048];
    private byte[] mRawdataBytes = new byte[52 * 75 * 2 + 64 * 2];
    private int[] mManualRefInt = new int[52 * 75 + 64];
    private int[] datatemp = new int[52 * 75 + 64];
    private int[] iDataShow = new int[52 * 75 + 64];

    private static final int CONNECTED_SUCCESS = 0;
    private static final int CLEAR_MESSAGE= 1;
    private static final int RAWDATA_MESSAGE = 2;
    private static final int DIFFDATA_2BYTES_MESSAGE = 3;
    private static final int DIFF_MESSAGE = 4;
    private static final int REFFDATA_MESSAGE = 5;
    private static final int MANUALDIFF_MESSAGE = 6;
    private static final int STYLUS_DATA_MESSAGE = 7;

    private static final int NEXT_COMMAND_DELAY_TIME = 150;            //下一个USB命令发送前延时时间
    private static final String USB_ACTION = "com.host2device";
    private static final String ACTION_USB_PERMISSION = "com.host2device.USB_PERMISSION";
    private ExecutorService mThreadPool;
    private UsbManager mUsbManager;
    private OpenDevicesReceiver daOpenDevicesReceiver;
    private UsbDeviceConnection mUsbDeviceConnection;
    private UsbRequest mUsbRequest = new UsbRequest();
    private UsbEndpoint mUsbEndpointOut;
    private UsbEndpoint mUsbEndpointIn;
    private int iProductId;
    private byte byProductType = 0;
    private static final byte CHIP_TYPE_UNKNOW = 0;
    private static final byte GT9 = 0x01;
    private static final byte GT9P = 0x02;
    private static final byte GT738x = 0x03;
    private static final byte GT29336 = 0x04;  //CHIP_TYPE_BERLINB
    private static final byte GT989x = 0x05;   //CHIP_TYPE_BERLINA
    private static final byte GT2931 = 0x06;   //CHIP_TYPE_BERLIND

    private Button btn_RawdataShow;
    private Button btn_DiffdataShow;
    private Button btn_ReffdataShow;
    private Button btn_ManualdiffdataShow;
    private Button btn_Manualreff;
    private Button btn_StylusDataShow;
    private Button btn_Stop;

    private EditText edt_RowNum;
    private EditText edt_ColNum;

    private boolean isReceiverMessage = true;
    private boolean isNeedFindDevice  = true;

    private UsbInterface mUsbInterface;
    private Context mContext;

    private byte showAddressHigh;
    private byte showAddressLow;  //需要显示的 address
    private int colnum;
    private int rownum;
    private TextView tvMaximum;      //显示最大值
    private TextView tvMinimum;      //显示最小值
    private TextView tvDataContent;  //显示当前处于何种数值模式：原始值、差值、基准……
    private TextView tvMAD;          //显示最大相邻偏差

    private byte showFlag = 0;  //
    private static final byte RAWDATA_FLAG = 0x01;           //rawdata
    private static final byte MANUALDATA_FLAG = 0x02;        //manualdiff and manualreff
    private static final byte DIFFDATA_1BYTE_FLAG = 0x03;    //1 byte diffdata(GT9xxx)
    private static final byte DIFFDATA_2BYTES_FLAG = 0x04;   //2 bytes diffdata
    private static final byte REFFDATA_FLAG = 0x05;          //reffdata
    private static final byte STYLUSDATA_FLAG = 0x08;        //stylus data
    private static final byte STOP_FLAG = 0x09;              //stop

    private boolean bShowDataFlag = false;

    private GridLayout textGridLayout;
    private List<Integer> ilShowData;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_dataanalysis);
        mAlertContext = DataAnalysis.this;
        //ConstantsActivity.activityList.add(this);
        //setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
        //switchLanguage(ConstantsActivity.langae);
        InitButton();
        InitEditText();
        InitListener();
        InitData();
        initTextView();
		openDevices();
    }

    //核心设置的代码
    protected void switchLanguage(String language) {
        Resources resources = getResources();
        Configuration config = resources.getConfiguration();
        DisplayMetrics dm = resources.getDisplayMetrics();
        switch (language) {
            case "zh":
                config.locale = Locale.CHINESE;
                resources.updateConfiguration(config, dm);
                break;
            case "en":
                config.locale = Locale.ENGLISH;
                resources.updateConfiguration(config, dm);
                break;
            default:
                config.locale = Locale.US;
                resources.updateConfiguration(config, dm);
                break;
        }
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig) {
        super.onConfigurationChanged(newConfig);
    }

    private void InitButton(){
        btn_RawdataShow = findViewById(R.id.rawdata);
        btn_DiffdataShow = findViewById(R.id.diffdata);
        btn_ReffdataShow = findViewById(R.id.reffdata);
        btn_ManualdiffdataShow = findViewById(R.id.manualdiff);
        btn_Manualreff = findViewById(R.id.manualreff);
        btn_StylusDataShow = findViewById(R.id.stylusdata);
        btn_Stop = findViewById(R.id.stop);

        btn_RawdataShow.setEnabled(false);
        btn_DiffdataShow.setEnabled(false);
        btn_ReffdataShow.setEnabled(false);
        btn_ManualdiffdataShow.setEnabled(false);
        btn_Manualreff.setEnabled(false);
        btn_StylusDataShow.setEnabled(false);
        //btn_Stop.setEnabled(false);
    }

    private void InitEditText(){
        edt_RowNum = findViewById(R.id.inputrownum);
        edt_ColNum = findViewById(R.id.inputcolnum);
    }

    private void InitListener(){
        btn_RawdataShow.setOnClickListener(this);
        btn_DiffdataShow.setOnClickListener(this);
        btn_ReffdataShow.setOnClickListener(this);
        btn_ManualdiffdataShow.setOnClickListener(this);
        btn_Manualreff.setOnClickListener(this);
        btn_StylusDataShow.setOnClickListener(this);
        btn_Stop.setOnClickListener(this);
    }

    private void InitData(){
        textGridLayout = findViewById(R.id.AllGridLayout);
    }

    public void initTextView() {
        tvMaximum = findViewById(R.id.maximumshow);
        tvMinimum = findViewById(R.id.minimumshow);
        tvDataContent = findViewById(R.id.datacontentshow);
        tvMAD = findViewById(R.id.madshow);
    }

    protected void onActivityResult ( int requestCode, int resultCode, Intent data){
        if (resultCode == Activity.RESULT_OK) {

            int permission_write = ContextCompat.checkSelfPermission(DataAnalysis.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
            int permission_read = ContextCompat.checkSelfPermission(DataAnalysis.this, Manifest.permission.READ_EXTERNAL_STORAGE);

            if ((permission_write != PackageManager.PERMISSION_GRANTED)
                    ||(permission_read != PackageManager.PERMISSION_GRANTED))
            {

                ActivityCompat.requestPermissions(DataAnalysis.this, new String[]{android.Manifest.permission.WRITE_EXTERNAL_STORAGE,
                        android.Manifest.permission.READ_EXTERNAL_STORAGE}, 3);
            }

            StringBuffer buffer = new StringBuffer();
            String configString = "";
            Uri uri = data.getData();
            String fileString = "";
            if (requestCode == 1 && resultCode == Activity.RESULT_OK) {  //U 盘 文 件

                //uri = null;
                //if (data != null){
                //    uri = data.getData();
                //}

                try {
                    InputStream inputStream = getContentResolver().openInputStream(uri);
                    BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
                    String line;
                    StringBuilder stringBuilder = new StringBuilder();

                    while ((line = reader.readLine()) != null){
                        stringBuilder.append(line);
                    }

                    reader.close();

                } catch (IOException c) {
                    return;
                }
            }  //end of if (requestCode == 1)
            else if (requestCode == 2) {  //本 地 文 件

                try {
                    File dir = Environment.getExternalStorageDirectory();
                    //Uri uri = data.getData();
                    File dataFile;

                    fileString = dir.getPath() + "/";

                    if (uri.getLastPathSegment().indexOf(":") > 0){
                        String[] stringFileNameArr = uri.getLastPathSegment().split(":");
                        fileString += stringFileNameArr[1];
                    }else{
                        fileString += uri.getLastPathSegment();
                    }

                    //fileString = dir.getPath() + "/" + uri.getLastPathSegment();

                    //File dir = Environment.getExternalStorageDirectory();
                    //dataFile = new File(dir.getPath(), "GTxxxx_wingcool_config.cfg");
                    dataFile = new File(fileString);

                    FileInputStream fis = new FileInputStream(dataFile);
                    //byte[] bytes = new byte[fis.available()];
                    //fis.read(bytes);
                    //fis.close();
                    //String str = new String(bytes,"utf-8");

                    //FileInputStream fis = new FileInputStream(uri.getPath().toString());
                    InputStreamReader isr = new InputStreamReader(fis, "UTF-8");//文件编码Unicode,UTF-8,ASCII,GB2312,Big5
                    Reader in = new BufferedReader(isr);
                    int ch;
                    while ((ch = in.read()) > -1) {
                        buffer.append((char) ch);
                    }
                    in.close();

                    configString = buffer.toString();

                } catch (IOException c) {
                    return;
                }
            }  //end of else if (requestCode == 2)

        }  //end of if (resultCode == Activity.RESULT_OK)
    }

    /**
     * 打开设备 , 让车机和手机端连起来
     */
    public void openDevices() {

        mThreadPool = Executors.newFixedThreadPool(5);
        mContext = getApplicationContext();
        mUsbManager = (UsbManager) getSystemService(Context.USB_SERVICE);
        //列举设备(手机)
        daOpenDevicesReceiver = new OpenDevicesReceiver(this);
        mThreadPool.execute(new Runnable() {
            @Override
            public void run() {
                SystemClock.sleep(1000);
                PendingIntent pendingIntent = PendingIntent.getBroadcast(mContext, 0, new Intent(ACTION_USB_PERMISSION), 0);
                IntentFilter intentFilter = new IntentFilter(USB_ACTION);

                registerReceiver(daOpenDevicesReceiver, intentFilter);
                while(isNeedFindDevice) {
                    SystemClock.sleep(100);
                    HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
                    if (deviceList != null) {
                        for (UsbDevice usbDevice : deviceList.values()) {
                            //int productId = usbDevice.getProductId();
                            int vendorId = usbDevice.getVendorId();
                            if ((vendorId == 0x27C0)          //之前VID错误了，做兼容
                                    ||(vendorId == 0x27C6)    //汇顶的VID
                                    ||(vendorId == 0x222A)    //奕力的VID
                                    ||(vendorId == 0x056A))   //8191主动笔和Wacom主动笔
                            {
                                if (mUsbManager.hasPermission(usbDevice)) {
                                    initDevice();
                                } else {
                                    mUsbManager.requestPermission(usbDevice, pendingIntent);
                                    break;
                                }
                                break;
                            }
                        }
                    }
                }
            }   //ThreadPool
        });
    }

    /**
     * 初始化设备(手机) , 当手机进入Accessory模式后 , 手机的PID会变为Google定义的2个常量值其中的一个 ,
     */
    private void initDevice() {
        HashMap<String, UsbDevice> deviceList = mUsbManager.getDeviceList();
        Collection<UsbDevice> values = deviceList.values();
        if (!values.isEmpty()) {
            for (UsbDevice usbDevice : values) {
                //int productId = usbDevice.getProductId();
                int vendorId = usbDevice.getVendorId();
                //if (productId == 0x0818 || productId == 0x0001 )
                if ((vendorId == 0x27C0)          //之前VID错误了，做兼容
                        ||(vendorId == 0x27C6)    //汇顶的VID
                        ||(vendorId == 0x222A)    //奕力的VID
                        ||(vendorId == 0x056A))   //8191主动笔和Wacom主动笔
                {
                    if (mUsbManager.hasPermission(usbDevice)) {

                        UsbInterface usbInterface = usbDevice.getInterface(1);

                        for (int i = 0; i < usbInterface.getEndpointCount(); i++) {
                            UsbEndpoint ep = usbInterface.getEndpoint(i);

                            if (ep.getDirection() == UsbConstants.USB_DIR_OUT) {
                                //mUsbEndpointIn = ep;
                                mUsbEndpointOut = ep;
                            } else {
                                //mUsbEndpointOut = ep;
                                mUsbEndpointIn = ep;
                            }
                        }

                        if ((null == mUsbEndpointIn) || (null == mUsbEndpointOut)) {
                            mUsbDeviceConnection = mUsbManager.openDevice(usbDevice);
                            if (mUsbDeviceConnection!=null) {
                                int i = mUsbDeviceConnection.controlTransfer(0x00, 0x09,
                                        0x002, 0, null, 0, 100);
                                SystemClock.sleep(1000);
                                if (i >= 0) {
                                    //mHandler.sendEmptyMessage(DEBUG_MESSAGE_SUCCESS);
                                } else {
                                    //mHandler.sendEmptyMessage(DEBUG_MESSAGE_ERROR);
                                }
                            }
                        } else {
                            isNeedFindDevice = false;
                            mUsbInterface = usbInterface;
                            mUsbDeviceConnection = mUsbManager.openDevice(usbDevice);
                            mUsbDeviceConnection.claimInterface(mUsbInterface, true);
                            if(null != mUsbEndpointIn){
                                iProductId = usbDevice.getProductId();

                                mHandler.sendEmptyMessage(CONNECTED_SUCCESS);
                            }
                        }
                    } else {
                        mUsbManager.requestPermission(usbDevice, PendingIntent.getBroadcast(mContext, 0, new Intent(""), 0));
                    }
                }
            }
        } else {
            // finish();
        }
    }

    private byte iicByteData[]={
            //0    1   2     3    4    5    6
            0x03,0x00,0x0f,0x00,0x00,0x00,0x01,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

    };
    private byte iicWriteData[]={
            //0    1   2     3    4    5    6
            0x03,0x00,0x0f,0x00,0x00,0x00,0x39,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
            0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

    };

    //发送命令，使得S818可以通过IIC向GT9的固定地址读取任意bytes的数据
    private boolean iicRead(byte addressHigh,byte addressLow,byte[] wBuffer,int length) {

        int i;

        iicByteData[1] = 0x00; //read GT9 command
        iicByteData[2] = 0x0f; //no command
        iicByteData[3] = addressHigh;
        iicByteData[4] = addressLow;
        iicByteData[5] = 0x00;
        iicByteData[6] = 63;  //length 一次接收63个数据

        for (int j = 7; j < 64; j++) {
            iicByteData[j] = 0x00;
        }

        int address1 = ((addressHigh&0xff)<<8);
        int address2 = addressLow&0xff;
        int address = address1|address2;

        int sendTimes = length/63;  //预计是向下取整，所以+1

        if ((length % 63) != 0)
        {
            sendTimes += 1;   //预计是向下取整，所以+1
        }

        for (int k = 0; k < sendTimes; k++) {
            int finalOffset = k*63; //每次只能发57bytes数据
            int offset = k*64;

            if(length - (finalOffset ) < 63) {

                iicByteData[6] = (byte) (length - (finalOffset));  //length
            }
            else
            {
                iicByteData[6] = 63;
            }

            //发送读取命令
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicByteData, 0, 0x40, 100);
            if (i != 0x40)
                return false;  //传输失败
            // SystemClock.sleep(1);

            isReceiverMessage = false;  //先关闭循环接收信息

            //接收数据
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointIn, wBuffer, offset, 0x40, 3000);

            if (i != 0x40) {
                return false;
            }

            address = address + 63;
            iicByteData[3] = (byte)(address>>8);
            iicByteData[4] = (byte)address;
        }

        //将report id从数组中去除
        //byte[] temperBuffer =new byte[length];
        if(true) {
            int count1 = 0;
            for (int k = 0; k < length; k++) {
                if (k % 63 == 0) {
                    count1++;
                }

                wBuffer[k] = wBuffer[k + count1];

            }
        }
        return true;
    }
    //发送命令，使得S818可以通过IIC向GT9的固定地址写任意bytes的数据
    private  boolean iicWrite(byte addressHigh,byte addressLow,byte[] wBuffer,int offset,int length) {
        int i;

        iicWriteData[1] = 0x01; //write GT9 command
        iicWriteData[2] = 0x0f; //no command
        iicWriteData[3] = addressHigh;
        iicWriteData[4] = addressLow;
        iicWriteData[5] = 0x00;
        iicWriteData[6] = 0x39;  //length

        int address1 = ((addressHigh&0xff)<<8);
        int address2 = addressLow&0xff;
        int address = address1|address2;

        int sendTimes = length/57 + 1;  //预计是向下取整，所以+1

        for (int k = 0; k < sendTimes; k++) {
            int finalOffset = offset + k*57; //每次只能发57bytes数据

            if(length - (finalOffset -offset) < 57) {

                iicWriteData[6] = (byte) (length - (finalOffset -offset));  //length
            }
            else
            {
                iicWriteData[6] = 0x39;
            }

            int j;
            for (j = 7; j < iicWriteData[6] + 7; j++) {
                iicWriteData[j] = wBuffer[finalOffset + j -7];
            }
            for (; j < 64; j++) {
                iicWriteData[j] = 0;
            }
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicWriteData, 0, 0x40, 100);

            if (i != 0x40) {
                return false;
            }

            address = address + 57;
            iicWriteData[3] = (byte)((address & 0xff00) >> 8);
            iicWriteData[4] = (byte)(address & 0xff);
        }

        return true;
    }


    //发送命令，使得S818可以通过IIC向GT9的固定地址写1byte数据
    private  boolean iicByteWrite(byte addressHigh,byte addressLow,byte subCommand,byte data) {
        int i;

        iicByteData[1] = 0x01; //write GT9 command
        iicByteData[2] = subCommand;
        iicByteData[3] = addressHigh;
        iicByteData[4] = addressLow;
        iicByteData[5] = 0x00;
        iicByteData[6] = 0x01;  //length

        iicByteData[7] = data;
        if ((null == mUsbEndpointIn) || (null == mUsbEndpointOut)){
            i=0;
        }
        else {
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicByteData, 0, 0x40, 100);
        }
        // i = 0;
        if(i == 0x40)
            return true;
        else
            return false;
    }

    //发送命令，使得S818可以通过IIC向GT9的固定地址读取1byte数据
    private byte iicByteRead(byte addressHigh,byte addressLow) {

        iicByteData[1] = 0x00; //read GT9 command
        iicByteData[2] = 0x0f;  //no command
        iicByteData[3] = addressHigh;
        iicByteData[4] = addressLow;
        iicByteData[5] = 0x00;   //length
        iicByteData[6] = 0x01;   //lengthlow

        iicByteData[7] = 0x00;

        int i;

        i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicByteData, 0, 0x40, 100);
        if (i != 0x40)
            return 0x77;  //用0x77来表示传输失败

        //SystemClock.sleep(12);  //加长时间，避免数据显示错乱乱闪
        SystemClock.sleep(24);  //加长时间，避免数据显示错乱乱闪

        isReceiverMessage = false;  //先关闭循环接收信息

        i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointIn, mBytes, 0, 0x40, 3000);

        //SystemClock.sleep(12);  //加长时间，避免数据显示错乱乱闪
        SystemClock.sleep(24);  //加长时间，避免数据显示错乱乱闪

        if (i == 0x40)
            return mBytes[1];
        else
            return 0x77;  //用0x77来表示传输失败
    }

    //发送命令，使得S8xx可以通过IIC向GT29xx的固定地址读取任意bytes的数据
    private boolean iicRead32Bits(byte addrfirstbyte,byte addrsecondbyte,byte addrthirdbyte,byte subCommand,byte[] wBuffer,int length) {

        int i;

        iicByteData[1] = (byte)(0 | subCommand);//0x0f; //7bit:0-read,1-write;other:command
        //iicByteData[2] = 0x0f; //no command
        iicByteData[2] = addrfirstbyte;
        iicByteData[3] = addrsecondbyte;
        iicByteData[4] = addrthirdbyte;
        iicByteData[5] = 0x00;
        iicByteData[6] = 63;  //length 一次接收63个数据

        for (int j = 7; j < 64; j++) {
            iicByteData[j] = 0x00;
        }

        int address1 = ((addrsecondbyte & 0xff) << 8);
        int address2 = addrthirdbyte & 0xff;
        int address = address1 | address2;

        int sendTimes = length / 63;  //预计是向下取整，所以+1

        if ((length % 63) != 0)
        {
            sendTimes += 1;   //预计是向下取整，所以+1
        }
        //iicByteData[5] = (byte)(length>>8);
        //iicByteData[6] = (byte)length;  //length 一次接收63个数据

        for (int k = 0; k < sendTimes; k++)
        {
            int finalOffset = k*63; //每次只能发57bytes数据
            int offset = k * 64;

            if(length - (finalOffset ) < 63) {

                iicByteData[6] = (byte) (length - (finalOffset));  //length
            }
            else
            {
                iicByteData[6] = 63;
            }

            //发送读取命令
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicByteData, 0, 0x40, 100);
            if (i != 0x40)
                return false;  //传输失败

            // SystemClock.sleep(1);

            //接收数据
            // i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointIn, wBuffer, offset, 0x40, 100);
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointIn, wBuffer, offset, 0x40, 100);

            //if (i != 0x40) {
            if (i != 0x40) {
                //editname.setText("IIC Read Failed!!");
                return false;

            }

            address = address + 63;
            iicByteData[3] = (byte)(address>>8);
            iicByteData[4] = (byte)address;
        }

        //将report id从数组中去除
        //byte[] temperBuffer =new byte[length];
        if(true) {
            int count1 = 0;
            for (int k = 0; k < length; k++) {
                if (k % 63 == 0) {
                    count1++;
                }

                wBuffer[k] = wBuffer[k + count1];

            }
        }
        return true;
    }

    //发送命令，使得S8xx可以通过IIC向GT79xx的固定地址写任意bytes的数据
    private  boolean iicWrite32Bits(byte addrfirstbyte,byte addrsecondbyte,byte addrthirdbyte,byte subCommand,byte[] wBuffer,int offset, int length) {

        int i;

        iicWriteData[1] = (byte)(0x80 | subCommand);//0x0f; //7bit:0-read,1-write;other:command
        //iicWriteData[2] = 0x0f; //no command
        iicWriteData[2] = addrfirstbyte;
        iicWriteData[3] = addrsecondbyte;
        iicWriteData[4] = addrthirdbyte;
        iicWriteData[5] = 0x00;
        iicWriteData[6] = 63;  //length 一次接收63个数据

        for (int j = 7; j < 64; j++) {
            iicWriteData[j] = 0x00;
        }

        int address1 = ((addrsecondbyte&0xff)<<8);
        int address2 = addrthirdbyte&0xff;
        int address = address1|address2;

        int sendTimes = length/57 + 1;  //预计是向下取整，所以+1

        //iicByteData[5] = (byte)(length>>8);
        //iicByteData[6] = (byte)length;  //length 一次接收63个数据

        for (int k = 0; k < sendTimes; k++) {
            int finalOffset = offset + k*57; //每次只能发57bytes数据

            if(length - (finalOffset -offset) < 57) {

                iicWriteData[6] = (byte) (length - (finalOffset -offset));  //length
            }
            else
            {
                iicWriteData[6] = 0x39;
            }

            for (int j = 7; j < 64; j++) {
                iicWriteData[j] = wBuffer[finalOffset + j -7];
            }
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicWriteData, 0, 0x40, 100);

            if (i != 0x40) {
                //mShow.setText("iicWrite Failed");
                return false;

            }

            address = address + 57;
            //iicWriteData[2] = (byte)((address & 0xFF0000) >> 16);
            iicWriteData[3] = (byte)(address >> 8);
            iicWriteData[4] = (byte)address;
        }

        return true;
    }

    //发送命令，使得S818可以通过IIC向GT9的固定地址写1byte数据
    private  boolean IicWriteOneByte(byte addrfirstbyte,byte addrsecondbyte,byte addrthirdbyte,byte subCommand,byte data) {
        int i;

        iicByteData[1] = (byte)(0x80 | subCommand); //write GT9 command
        iicByteData[2] = addrfirstbyte;
        iicByteData[3] = addrsecondbyte;
        iicByteData[4] = addrthirdbyte;
        iicByteData[5] = 0x00;
        iicByteData[6] = 0x01;  //length

        iicByteData[7] = data;
        if ((null == mUsbEndpointIn) || (null == mUsbEndpointOut)){
            i=0;
        }
        else {
            i = mUsbDeviceConnection.bulkTransfer(mUsbEndpointOut, iicByteData, 0, 0x40, 100);
        }
        // i = 0;
        if(i == 0x40)
            return true;
        else
            return false;
    }

    private boolean changeToDebugMode() {
        int i;
        int length = 0;

        mBytes[0] = 0x00;
        iicWrite32Bits((byte) 0x01, (byte) 0x02, (byte) 0x74, (byte)0x06, mBytes, 0, 1);  //send 6 to usb ic,change to debug mode

        SystemClock.sleep(NEXT_COMMAND_DELAY_TIME);

        //switch to read data mode
        if (showFlag == RAWDATA_FLAG || showFlag == MANUALDATA_FLAG) {
            if (byProductType == GT29336) {  //send 0x00 0x00 0x04 0x02 0x06 0x00 to [0x10174],read rawdata
                mBytes[0] = 0x00;
                mBytes[1] = 0x00;
                mBytes[2] = 0x04;
                mBytes[3] = 0x02;
                mBytes[4] = 0x06;
                mBytes[5] = 0x00;

                length = 6;
            }else if (byProductType == GT2931){
                mBytes[0] = 0x00;
                mBytes[1] = 0x00;
                mBytes[2] = 0x05;
                mBytes[3] = (byte)0x90;
                mBytes[4] = (byte)0x81;
                mBytes[5] = 0x16;
                mBytes[6] = 0x01;

                length = 7;
            }
        }
        else if (showFlag == DIFFDATA_2BYTES_FLAG)
        {
            if (byProductType == GT29336) {  //send 0x00 0x00 0x04 0x01 0x05 0x00 to [0x10174],read diffdata
                mBytes[0] = 0x00;
                mBytes[1] = 0x00;
                mBytes[2] = 0x04;
                mBytes[3] = 0x01;
                mBytes[4] = 0x05;
                mBytes[5] = 0x00;

                length = 6;
            }else if (byProductType == GT2931) {
                mBytes[0] = 0x00;
                mBytes[1] = 0x00;
                mBytes[2] = 0x05;
                mBytes[3] = (byte)0x90;
                mBytes[4] = (byte)0x82;
                mBytes[5] = 0x17;
                mBytes[6] = 0x01;

                length = 7;
            }
        }
        for (i = 0; i < 5; i++) {
            if (!iicWrite32Bits((byte) 0x01, (byte) 0x01, (byte) 0x74, (byte)0x0f, mBytes, 0, length)) {
                SystemClock.sleep(1);
                continue;
            }
            else {
                break;
            }
        }
        if (i == 5)
        {
            return false;
        }

        iicWrite32Bits((byte) 0x01, (byte) 0x02, (byte) 0x74, (byte)0x0f, mBytes, 0, 1);

        //15ms一次轮询[0x10174]，如果是0x80，说明GT29XX进入读数据模式
        do {
            SystemClock.sleep(15);
            iicRead32Bits((byte)0x01, (byte)0x01, (byte)0x74, (byte)0x0f, mBytes, 1);
        }while(mBytes[0] != (byte)0x80);

        return true;
    }

    private boolean changeToNormalMode() {

        int i;
        int length = 0;

        if (byProductType == GT29336) {  //switch to normal mode, send 0x00 0x00 0x04 0x00 0x04 0x00 to [0x10174]
            mBytes[0] = 0x00;
            mBytes[1] = 0x00;
            mBytes[2] = 0x04;
            mBytes[3] = 0x00;
            mBytes[4] = 0x04;
            mBytes[5] = 0x00;

            length = 6;
        }else if (byProductType == GT2931) {
            mBytes[0] = 0x00;
            mBytes[1] = 0x00;
            mBytes[2] = 0x05;
            mBytes[3] = (byte)0x91;
            mBytes[4] = (byte)0x81;
            mBytes[5] = 0x17;
            mBytes[6] = 0x01;

            length = 7;
        }

        for (i = 0; i < 5; i++) {
            if (!iicWrite32Bits((byte) 0x01, (byte) 0x01, (byte) 0x74, (byte)0x0f, mBytes, 0, length)) {
                SystemClock.sleep(1);
                continue;
            }else{
                break;
            }
        }
        if (i == 5)
        {
            return false;
        }

        mBytes[0] = 0x00;
        iicWrite32Bits((byte) 0x01, (byte) 0x02, (byte) 0x74, (byte)0x07, mBytes, 0, 1);  //send 7 to usb ic,change to normal mode

        return true;
    }

    private boolean getRawdata() {

        byte maddressHigh;
        byte maddressLow;  //rawdata address
        byte msubcommand = (byte)0x0d;  //  READ_SYNC
        byte mdata;
        int ilength = colnum * rownum * 2;

        if (showFlag == STYLUSDATA_FLAG)
        {
            ilength = (colnum + rownum + 2) * 2;
        }

        switch (showFlag){
            case RAWDATA_FLAG:  //rawdata
            case MANUALDATA_FLAG:  //manual diffdata
                if (byProductType == GT29336) {
                    if (!iicRead32Bits((byte) 0x01, (byte) 0xA6, (byte) 0x7C, (byte)0x0f, mRawdataBytes, ilength)) {
                        return false;
                    }
                }else if(byProductType == GT2931) {
                    if (!iicRead32Bits((byte) 0x01, (byte) 0x40, (byte) 0xFC, (byte)0x0f, mRawdataBytes, ilength)) {
                        return false;
                    }
                }
                break;

            case DIFFDATA_2BYTES_FLAG:  //diffdata低位在前
            //case DIFFDATA_1BYTE_FLAG:  //diffdata
                if (byProductType == GT29336) {
                    if (!iicRead32Bits((byte) 0x01, (byte) 0xC1, (byte) 0x4C, (byte)0x0f, mRawdataBytes, ilength)) {
                        return false;
                    }
                }else if (byProductType == GT2931) {
                    if (!iicRead32Bits((byte) 0x01, (byte) 0x11, (byte) 0xB0, (byte)0x0f, mRawdataBytes, ilength)) {
                        return false;
                    }
                }
                break;

            case REFFDATA_FLAG:  //reffdata
                if (byProductType == GT29336) {
                    if (!iicRead32Bits((byte) 0x01, (byte) 0x8b, (byte) 0xaC, (byte)0x0f, mRawdataBytes, ilength)) {
                        return false;
                    }
                }else if (byProductType == GT2931) {
                    if (!iicRead32Bits((byte) 0x01, (byte) 0x3A, (byte) 0xBC, (byte)0x0f, mRawdataBytes, ilength)) {
                        return false;
                    }
                }
                break;

            default:
                break;
        }

        int tempcol = 0;
        int i = 0;

        if (showFlag != STYLUSDATA_FLAG)  {
            //控制行数
            for (int row = 0; row < rownum; row++) {  //Sen
                //控制列数
                for (int col = 0; col < colnum; col++) {  //Drv

                    int idtemp = (row + tempcol * rownum);

                    idtemp = idtemp * 2;
                    //低位在前
                    datatemp[i] = ((mRawdataBytes[idtemp + 1] & 0xFF) << 8) + (mRawdataBytes[idtemp] & 0xFF);

                    tempcol++;

                    i++;
                }
                tempcol = 0;
            }
        }

        while(bShowDataFlag == true){  //上一次的数据显示还没结束则一直等待
            SystemClock.sleep(1);
        }

        for (i = 0; i < 75 * 52; i++) {
            iDataShow[i] = (short)datatemp[i];
        }

        if ((showFlag == MANUALDATA_FLAG) && (count == 999))   //第一帧备份rawdata作为基准
        {
            if (byProductType == GT9)
            {
                for (i = 0; i < 42 * 30; i++) {
                    //int j = i / 2;
                    mManualRefInt[i] = iDataShow[i];//((mRawdataBytes[i] & 0xFF) << 8) + (mRawdataBytes[i + 1] & 0xFF);
                    //i++;
                }
            } else if (byProductType == GT738x) {
                for (i = 0; i < 44 * 72; i++) {
                    //int j = i / 2;
                    mManualRefInt[i] = iDataShow[i];//((mRawdataBytes[i + 1] & 0xFF) << 8) + (mRawdataBytes[i] & 0xFF);
                    //i++;
                }
            } else if (byProductType == GT29336) {
                for (i = 0; i < 75 * 52; i++) {
                    mManualRefInt[i] = iDataShow[i];
                }
            } else if (byProductType == GT2931) {
                for (i = 0; i < 75 * 52; i++) {
                    mManualRefInt[i] = iDataShow[i];
                }
            }

        }

        if ((showFlag == RAWDATA_FLAG) || (showFlag == DIFFDATA_2BYTES_FLAG) || (showFlag == MANUALDATA_FLAG)) {
            if (byProductType == GT29336) {  //clear sync flag, [0x010274] = 0
                if (!IicWriteOneByte((byte) 0x01, (byte) 0x02, (byte) 0x74, (byte) 0x0f, (byte) 0)) {
                    return false;
                }
            } else if (byProductType == GT2931) {
                if (showFlag == RAWDATA_FLAG || (showFlag == MANUALDATA_FLAG))  //rawdata
                {
                    if (!IicWriteOneByte((byte) 0x01, (byte) 0x03, (byte) 0x08, (byte) 0x0f, (byte) 0)) {
                        return false;
                    }
                } else {  //diffdata
                    if (!IicWriteOneByte((byte) 0x01, (byte) 0x04, (byte) 0x00, (byte) 0x0f, (byte) 0)) {
                        return false;
                    }
                }
            }
        }

        return true;
    }

    int count = 1000;
    private void showRawdata() {

        mThreadPool.execute(new Runnable() {
            @Override
            public void run() {

                byte syncFlag = 1;

                byte maddressHigh = (byte) 0x81;
                byte maddressLow = (byte) 0x4E;  //SYNC address
                byte msubcommand = (byte) 0x0f;
                byte mdata = (byte) 0x00;

                byte addrfirstbyte, addrsecondbyte, addrthirdbyte;

                if (byProductType == GT738x) {
                    maddressHigh = (byte) 0x82;
                }

                int checktimes;
                while(showFlag != STOP_FLAG) {

                    if(count-- == 0)
                    {
                        count = 0;
                    }

                    if (showFlag == RAWDATA_FLAG || showFlag == DIFFDATA_2BYTES_FLAG || showFlag == MANUALDATA_FLAG) {
                        checktimes = 0;
                        while (true) {
                            if (byProductType == GT29336) {
                                if (!iicRead32Bits((byte) 0x01, (byte) 0x02, (byte) 0x74, (byte) 0x0f, mBytes, 1)) {  //轮询读取0x010274
                                    SystemClock.sleep(1);
                                    continue;
                                }
                            } else {

                                if (showFlag == RAWDATA_FLAG) {  //rawdata
                                    if (!iicRead32Bits((byte) 0x01, (byte) 0x03, (byte) 0x08, (byte) 0x0f, mBytes, 1)) {  //轮询读取0x010308
                                        SystemClock.sleep(1);
                                        continue;
                                    }
                                } else {  //diffdata
                                    if (!iicRead32Bits((byte) 0x01, (byte) 0x04, (byte) 0x00, (byte) 0x0f, mBytes, 1)) {  //轮询读取0x010400
                                        SystemClock.sleep(1);
                                        continue;
                                    }
                                }
                            }

                            if (mBytes[0] == (byte) 0x80)  //读到0x80则跳出去读数据
                            {
                                break;
                            }

                            if (checktimes++ > 20)  //轮询了20次没读到0x80，超时跳出去读数据
                            {
                                break;
                            }

                        }
                    }

                    if (getRawdata() == true) {

                        switch (showFlag) {
                            case RAWDATA_FLAG:  //rawdata
                                mHandler.sendEmptyMessage(RAWDATA_MESSAGE);
                                break;

                            case DIFFDATA_2BYTES_FLAG:  //2 bytes diffdata
                                mHandler.sendEmptyMessage(DIFFDATA_2BYTES_MESSAGE);
                                break;

                            case REFFDATA_FLAG:  //reffdate
                                mHandler.sendEmptyMessage(REFFDATA_MESSAGE);
                                break;

                            case MANUALDATA_FLAG:  //manual diff
                                mHandler.sendEmptyMessage(MANUALDIFF_MESSAGE);
                                // mHandler.sendEmptyMessage(RAWDATA_MESSAGE);
                                break;

                            case DIFFDATA_1BYTE_FLAG://diffdata
                                mHandler.sendEmptyMessage(DIFF_MESSAGE);
                                break;

                            case STOP_FLAG:  //stop
                                changeToNormalMode();
                                SystemClock.sleep(40);
                                showFlag = STOP_FLAG;
                                count = 1000;
                                SystemClock.sleep(10);
                                break;

                            case STYLUSDATA_FLAG:  //stylusdata
                                mHandler.sendEmptyMessage(STYLUS_DATA_MESSAGE);
                                break;

                            default:
                                break;
                        }//switch (showFlag)
                    } else {
                        IicWriteOneByte((byte)0x01, (byte)0x02, (byte)0x74, (byte)0x0f, (byte)0);
                    }
                }
            }   //ThreadPool
        });   //ThreadPool
        //   return true;
    }

    Handler mHandler = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            StringBuilder stringBuilder = new StringBuilder("");
            int idtemp;
            int i = 0;
            int tempcol = 0;
            int temprow = 0;
            String dv;
            int maxdata;
            int mindata;
            int itemp;  //临时存放

            switch (msg.what) {
                case CONNECTED_SUCCESS: //连接成功
                    btn_RawdataShow.setEnabled(true);
                    btn_DiffdataShow.setEnabled(true);
                    btn_ReffdataShow.setEnabled(true);
                    btn_ManualdiffdataShow.setEnabled(true);
                    //btn_Manualreff.setEnabled(false);
                    //btn_StylusDataShow.setEnabled(true);
                    iicRead32Bits((byte)0x01, (byte)0x00, (byte)0x14, (byte)47, mBytes, 2);
                    byProductType = mBytes[1];
                    break;

                case CLEAR_MESSAGE://清除数据
                    break;

                case RAWDATA_MESSAGE://

                    bShowDataFlag = true;  //开始显示

                    maxdata = -65535;
                    mindata = 65535;

                    for (i = 0; i < rownum * colnum; i++) {
                        int value = iDataShow[i];
                        ilShowData.set(i, value);
                        TextView cell = (TextView) textGridLayout.getChildAt(i);
                        cell.setText(String.valueOf(value));

                        //获取最大值
                        if (iDataShow[i] > maxdata){
                            maxdata = iDataShow[i];
                        }
                        //获取最小值
                        if (iDataShow[i] < mindata){
                            mindata = iDataShow[i];
                        }
                    }

                    tvMaximum.setText(Integer.toString(maxdata));
                    tvMinimum.setText(Integer.toString(mindata));

                    bShowDataFlag = false;  //显示结束
                    break;

                case DIFFDATA_2BYTES_MESSAGE:
                    bShowDataFlag = true;  //开始显示

                    maxdata = -65535;
                    mindata = 65535;

                    for (i = 0; i < rownum * colnum; i++) {
                        int value = iDataShow[i];
                        ilShowData.set(i, value);
                        TextView cell = (TextView) textGridLayout.getChildAt(i);
                        cell.setText(String.valueOf(value));

                        if (value > 0) {
                            // 正数越大红色越深
                            int intensity = (int) (255 * (Math.min(value, 600) / 600.0));
                            cell.setTextColor(Color.rgb(intensity, 0, 0));
                        } else {
                            // 负数越大蓝色越深
                            int intensity = (int) (255 * (Math.min(-value, 600) / 600.0));
                            cell.setTextColor(Color.rgb(0, 0, intensity));
                        }

                        //获取最大值
                        if (iDataShow[i] > maxdata){
                            maxdata = iDataShow[i];
                        }
                        //获取最小值
                        if (iDataShow[i] < mindata){
                            mindata = iDataShow[i];
                        }
                    }
                    
                    tvMaximum.setText(Integer.toString(maxdata));
                    tvMinimum.setText(Integer.toString(mindata));

                    bShowDataFlag = false;  //显示结束
                    break;

                case DIFF_MESSAGE://
                    bShowDataFlag = true;  //开始显示

                    maxdata = 0;
                    mindata = 65535;

                    for (int row = 0; row < rownum; row++) {  //Sen
                        //控制列数
                        for (int col = 0; col < colnum + 1; col++) {  //Drv

                            TextView textView = new TextView(mContext);
                            GridLayout.LayoutParams params = new GridLayout.LayoutParams();

                            if (col == 0){

                                dv = Integer.toString(row);
                                //if (row < 10){
                                //    dv = "0" + dv;
                                //}

                                //stringBuilder.append(dv);
                                //stringBuilder.append("│");

                            }else{

                                //idtemp = row + tempcol * rownum;
                                //if (byProductType == GT7)  //GT7的低位在前
                                //{
                                //    iDataShow[i] = ((mRawdataBytes[idtemp * 2 + 1] & 0xFF) << 8) + (mRawdataBytes[idtemp * 2] & 0xFF);
                                //}else{
                                //    iDataShow[i] = ((mRawdataBytes[idtemp * 2] & 0xFF) << 8) + (mRawdataBytes[idtemp * 2 + 1] & 0xFF);
                                //}

                                dv = Integer.toString(iDataShow[i]);

                                //stringBuilder.append(dv + "│");

                                tempcol++;

                                //获取最大值
                                if (iDataShow[i] > maxdata){
                                    maxdata = iDataShow[i];
                                }
                                //获取最小值
                                if (iDataShow[i] < mindata){
                                    mindata = iDataShow[i];
                                }

                                if (iDataShow[i] > 30){
                                    textView.setTextColor(Color.parseColor("#FF0000"));
                                }else if (iDataShow[i] < -30){
                                    textView.setTextColor(Color.parseColor("#0000FF"));
                                }

                                i++;

                                params.width = 50;
                            }


                            textView.setText(dv);
                            textView.setGravity(Gravity.CENTER);
                            params.setMargins(2,1,2,1);
                            //params.width = 45;
                            textGridLayout.addView(textView,params);
                        }
                        tempcol = 0;
                        //stringBuilder.append("\n");
                    }
                    tvMaximum.setText(Integer.toString(maxdata));
                    tvMinimum.setText(Integer.toString(mindata));

                    bShowDataFlag = false;  //显示结束
                    break;

                case REFFDATA_MESSAGE:
                    bShowDataFlag = true;  //开始显示

                    maxdata = -65535;
                    mindata = 65535;

                    for (i = 0; i < rownum * colnum; i++) {
                        int value = iDataShow[i];
                        ilShowData.set(i, value);
                        TextView cell = (TextView) textGridLayout.getChildAt(i);
                        cell.setText(String.valueOf(value));

                        //获取最大值
                        if (iDataShow[i] > maxdata){
                            maxdata = iDataShow[i];
                        }
                        //获取最小值
                        if (iDataShow[i] < mindata){
                            mindata = iDataShow[i];
                        }
                    }

                    tvMaximum.setText(Integer.toString(maxdata));
                    tvMinimum.setText(Integer.toString(mindata));

                    bShowDataFlag = false;  //显示结束
                    break;

                case MANUALDIFF_MESSAGE:
                    bShowDataFlag = true;  //开始显示

                    maxdata = -65535;
                    mindata = 65535;

                    for (i = 0; i < rownum * colnum; i++) {
                        int value = mManualRefInt[i] - iDataShow[i];
                        ilShowData.set(i, value);
                        TextView cell = (TextView) textGridLayout.getChildAt(i);
                        cell.setText(String.valueOf(value));

                        if (value > 0) {
                            // 正数越大红色越深
                            int intensity = (int) (255 * (Math.min(value, 600) / 600.0));
                            cell.setTextColor(Color.rgb(intensity, 0, 0));
                        } else {
                            // 负数越大蓝色越深
                            int intensity = (int) (255 * (Math.min(-value, 600) / 600.0));
                            cell.setTextColor(Color.rgb(0, 0, intensity));
                        }

                        //获取最大值
                        if (iDataShow[i] > maxdata){
                            maxdata = iDataShow[i];
                        }
                        //获取最小值
                        if (iDataShow[i] < mindata){
                            mindata = iDataShow[i];
                        }
                    }

                    tvMaximum.setText(Integer.toString(maxdata));
                    tvMinimum.setText(Integer.toString(mindata));

                    bShowDataFlag = false;  //显示结束
                    break;

                case STYLUS_DATA_MESSAGE:
                    int layindex = 0;

                    textGridLayout.removeAllViews();

                    for (int index = 0; index < (rownum + colnum + 2); index++) {  //驱动和感应数据之间留有2个空位为0

                        if ((index == colnum) || (index == (colnum + 1)))  //跳过两个空位
                        {
                            layindex = 0; //开始感应数据的排列

                            continue;
                        }

                        TextView textView = new TextView(mContext);
                        GridLayout.LayoutParams params = new GridLayout.LayoutParams();

                        datatemp[index] = ((mRawdataBytes[index * 2 + 1] & 0xFF) << 8) + (mRawdataBytes[index * 2] & 0xFF);

                        dv = Integer.toString(datatemp[index]);

                        if (datatemp[index] > 80) {
                            textView.setTextColor(Color.parseColor("#FF0000"));
                        }

                        layindex++;

                        params.width = 40;

                        textView.setText(dv);
                        textView.setGravity(Gravity.CENTER);
                        params.setMargins(2,1,2,1);

                        if (index < colnum) {  //驱动数据排列
                            params.columnSpec = GridLayout.spec(0, 1);  //列的位置
                            params.rowSpec = GridLayout.spec(layindex, 1);   //行的位置
                        }else{  //感应数据排列
                            params.columnSpec = GridLayout.spec(layindex,1);  //列的位置
                            params.rowSpec = GridLayout.spec(0,1);   //行的位置
                        }
                        //params.width = 45;
                        textGridLayout.addView(textView, params);
                    }

                    break;

                default:
                    break;
            }   //end of switch (msg.what)
        }
    };

    @Override
    public void onClick(final View view) {

        int checksum;
        int checksum2;
        byte addressH;
        byte addressL;
        int iConfigSize = 0;

        byte addrfirstbyte, addrsecondbyte, addrthirdbyte;

        switch (view.getId()) {

            case R.id.manualreff:  //set up manual ref
                showFlag = MANUALDATA_FLAG;
                btn_Manualreff.setEnabled(true);
                count = 1000;

                switch (byProductType)
                {
                    case CHIP_TYPE_UNKNOW:
                    case GT9:
                        showAddressHigh = (byte) 0x81;
                        showAddressLow = (byte) 0xc0;
                        break;

                    case GT738x:
                        showAddressHigh = (byte) 0xa5;
                        showAddressLow = (byte) 0x58;
                        break;

                    case GT29336:

                        break;

                    case GT2931:

                        break;

                    default:
                        break;
                }
                break;

            case R.id.stop:    //back
                showFlag = STOP_FLAG;

                btn_RawdataShow.setEnabled(true);
                btn_DiffdataShow.setEnabled(true);
                btn_ReffdataShow.setEnabled(true);
                btn_ManualdiffdataShow.setEnabled(true);
                btn_Manualreff.setEnabled(false);
                //btn_StylusDataShow.setEnabled(true);
                //count = 1000;
                //changeToNormalMode();
                break;

            default: {

                if (byProductType == GT738x) {
                    addressH = (byte) 0x80;
                    addressL = (byte) 0x50;

                    iicRead(addressH, addressL, mBytes, 444);

                    checksum = 0;
                    checksum2 = 0;
                    for (int i = 0; i < 444; i++) {
                        int k = mBytes[i] & 0xFF;
                        if (i < 213) {
                            checksum = checksum + k;
                        } else {
                            checksum2 = checksum2 + k;
                        }
                    }
                    if ((checksum % 256 == 0) && (checksum2 % 256 == 0))  //校验和正确
                    {
                        colnum = (mBytes[381] & 0xFF) + (mBytes[383] & 0xFF);  //DRV
                        rownum = (mBytes[380] & 0xFF) + (mBytes[382] & 0xFF);  //SEN
                    } else {
                        Toast.makeText(this, getResources().getString(R.string.cfgerror), Toast.LENGTH_SHORT).show();
                        return;
                    }
                } else {

                    //send 0x00 0x00 0x04 0x07 0x0B 0x00 to [0x10174]，通知GT29XX,要读cfg
                    mBytes[0] = 0x00;
                    mBytes[1] = 0x00;
                    mBytes[2] = 0x04;
                    mBytes[3] = 0x07;
                    mBytes[4] = 0x0B;
                    mBytes[5] = 0x00;
                    iicWrite32Bits((byte) 0x01, (byte) 0x01, (byte) 0x74, (byte)0x0f, mBytes, 0, 6);


                    //read [0x10175] = 0x80,config is ready
                    //do {
                    //    SystemClock.sleep(30);
                    //    iicRead32Bits((byte)0x01, (byte)0x01, (byte)0x75, (byte)0x0f, mBytes, 1);
                    //}while(mBytes[0] != (byte)0x80);

                    //read [0x10174] = 0x80,config is ready
                    do {
                        SystemClock.sleep(30);
                        iicRead32Bits((byte) 0x01, (byte) 0x01, (byte) 0x74, (byte)0x0f, mBytes, 1);
                    } while (mBytes[0] != (byte) 0x80);

                    //SystemClock.sleep(2);

                    if (byProductType == GT29336) {
                        addrfirstbyte = (byte) 0x01;
                        addrsecondbyte = (byte) 0x3B;
                        addrthirdbyte = (byte) 0x74;
                    } else {
                        addrfirstbyte = (byte) 0x01;
                        addrsecondbyte = (byte) 0x21;
                        addrthirdbyte = (byte) 0x8C;
                    }

                    //read buffer [0x13B74]/[0X1218C]
                    iicRead32Bits(addrfirstbyte, addrsecondbyte, addrthirdbyte, (byte)0x0f, mBytes, 63);  //read config head

                    iConfigSize = 64 + (int) (mBytes[60] & 0xFF) * 256 + (mBytes[59] & 0xFF);   //the head lend is 64

                    iicRead32Bits(addrfirstbyte, addrsecondbyte, addrthirdbyte, (byte)0x0f, mBytes, iConfigSize);  //read config

                    SystemClock.sleep(5);

                    if (byProductType == GT29336) {
                        colnum = (mBytes[67] & 0xFF);  //Drv Num
                        rownum = (mBytes[68] & 0xFF);  //Sen Num
                    } else if (byProductType == GT2931) {
                        colnum = (mBytes[66] & 0xFF);  //Drv Num
                        rownum = (mBytes[67] & 0xFF);  //Sen Num
                    }

                    //send 0x00 0x00 0x04 0x08 0x0C 0x00 to [0x10174]，通知GT29XX,通信结束
                    mBytes[0] = 0x00;
                    mBytes[1] = 0x00;
                    mBytes[2] = 0x04;
                    mBytes[3] = 0x08;
                    mBytes[4] = 0x0C;
                    mBytes[5] = 0x00;
                    iicWrite32Bits((byte) 0x01, (byte) 0x01, (byte) 0x74, (byte)0x0f, mBytes, 0, 6);

                    //read [0x10175] = 0x80,config is ready
                    //do {
                    //    SystemClock.sleep(30);
                    //    iicRead32Bits((byte)0x01, (byte)0x01, (byte)0x75, (byte)0x0f, mBytes, 1);
                    //}while(mBytes[0] != (byte)0x80);

                    //read [0x10175] = 0x80,read config is over
                    do {
                        SystemClock.sleep(30);
                        iicRead32Bits((byte) 0x01, (byte) 0x01, (byte) 0x74, (byte)0x0f, mBytes, 1);
                    } while (mBytes[0] != (byte) 0x80);

                    /*
                    if(checksum % 256 == 0)  //校验和正确
                    {
                        colnum = (mBytes[27] & 0x1F) + (mBytes[28] & 0x1F);
                        rownum = (mBytes[29] & 0x0F) + ((mBytes[29] & 0xFF) >> 4);

                        edt_ColNum.setText(Integer.toString(colnum));
                        edt_RowNum.setText(Integer.toString(rownum));
                    }
                    else {
                        Toast.makeText(this, getResources().getString(R.string.cfgerror), Toast.LENGTH_SHORT).show();
                        return;
                    }
                    */
                }

                if ((edt_ColNum.getText().length() == 0) || (edt_RowNum.getText().length() == 0)) {
                    edt_ColNum.setText(Integer.toString(colnum));
                    edt_RowNum.setText(Integer.toString(rownum));

                } else {
                    colnum = (byte) Integer.parseInt(edt_ColNum.getText().toString(), 10);
                    rownum = (byte) Integer.parseInt(edt_RowNum.getText().toString(), 10);
                }

                if (colnum == 0) {  //DRV
                    colnum = 42;
                    if (byProductType == GT738x) {
                        colnum = 44;
                    }
                    edt_ColNum.setText(Integer.toString(colnum));
                }

                if (rownum == 0) {  //SEN
                    rownum = 30;
                    if (byProductType == GT738x) {
                        rownum = 72;
                    }
                    edt_RowNum.setText(Integer.toString(rownum));
                }

                if (showFlag != STYLUSDATA_FLAG) {
                    textGridLayout.removeAllViews();

                    textGridLayout.setColumnCount(colnum);
                    textGridLayout.setRowCount(rownum);
                }

                btn_RawdataShow.setEnabled(false);
                btn_DiffdataShow.setEnabled(false);
                btn_ReffdataShow.setEnabled(false);
                btn_ManualdiffdataShow.setEnabled(false);
                btn_Manualreff.setEnabled(false);
                btn_StylusDataShow.setEnabled(false);

                switch (view.getId()) {
                    case R.id.rawdata:   //Read RawData

                        showFlag = RAWDATA_FLAG;

                        ilShowData = new ArrayList<>();
                        for (int i = 0; i < rownum * colnum; i++) {
                            int value = 0;
                            ilShowData.add(value);
                            TextView cell = new TextView(this);
                            cell.setText(String.valueOf(value));
                            cell.setPadding(2, 2, 2, 2);
                            cell.setWidth(80);
                            cell.setGravity(Gravity.CENTER);
                            textGridLayout.addView(cell);
                        }

                        changeToDebugMode();

                        tvDataContent.setText("[" + getResources().getString(R.string.rawdata) + "]");

                        showRawdata();
                        break;

                    case R.id.diffdata:

                        showFlag = DIFFDATA_2BYTES_FLAG;
                        if (byProductType == GT9)
                        {
                            showFlag = DIFFDATA_1BYTE_FLAG;
                        }

                        ilShowData = new ArrayList<>();
                        for (int i = 0; i < rownum * colnum; i++) {
                            int value = 0;
                            ilShowData.add(value);
                            TextView cell = new TextView(this);
                            cell.setText(String.valueOf(value));
                            cell.setPadding(2, 2, 2, 2);
                            cell.setWidth(80);
                            cell.setGravity(Gravity.CENTER);
                            textGridLayout.addView(cell);
                        }

                        changeToDebugMode();

                        tvDataContent.setText("[" + getResources().getString(R.string.diffdata) + "]");

                        showRawdata();

                        break;

                    case R.id.reffdata:  //暂时没用

                        showFlag = REFFDATA_FLAG;
                        count = 1000;

                        switch (byProductType)
                        {
                            case CHIP_TYPE_UNKNOW:
                            case GT9:
                                showAddressHigh = (byte) 0x81;
                                showAddressLow = (byte) 0xc0;
                                break;

                            case GT738x:
                                showAddressHigh = (byte) 0xa5;
                                showAddressLow = (byte) 0x58;
                                break;

                            case GT29336:

                                break;

                            case GT2931:

                                break;

                            default:
                                break;
                        }

                        ilShowData = new ArrayList<>();
                        for (int i = 0; i < rownum * colnum; i++) {
                            int value = 0;
                            ilShowData.add(value);
                            TextView cell = new TextView(this);
                            cell.setText(String.valueOf(value));
                            cell.setPadding(2, 2, 2, 2);
                            cell.setWidth(80);
                            cell.setGravity(Gravity.CENTER);
                            textGridLayout.addView(cell);
                        }

                        tvDataContent.setText("[" + getResources().getString(R.string.reffdata) + "]");

                        showRawdata();
                        break;

                    case R.id.manualdiff:
                        showFlag = MANUALDATA_FLAG;

                        ilShowData = new ArrayList<>();
                        for (int i = 0; i < rownum * colnum; i++) {
                            int value = 0;
                            ilShowData.add(value);
                            TextView cell = new TextView(this);
                            cell.setText(String.valueOf(value));
                            cell.setPadding(2, 2, 2, 2);
                            cell.setWidth(80);
                            cell.setGravity(Gravity.CENTER);
                            textGridLayout.addView(cell);
                        }

                        changeToDebugMode();

                        switch (byProductType)
                        {
                            case CHIP_TYPE_UNKNOW:
                            case GT9:
                                showAddressHigh = (byte) 0x81;
                                showAddressLow = (byte) 0xc0;
                                break;

                            case GT738x:
                                showAddressHigh = (byte) 0xa5;
                                showAddressLow = (byte) 0x58;
                                break;

                            case GT29336:

                                break;

                            case GT2931:

                                break;

                            default:
                                break;
                        }

                        btn_Manualreff.setEnabled(true);

                        if (count == 1000) {
                            tvDataContent.setText("[" + getResources().getString(R.string.manualdiff) + "]");
                            showRawdata();
                        } else {
                            count = 1000;
                        }

                        break;

                    case R.id.stylusdata:  //主动笔数据
                        if (byProductType == GT738x)  //GT7系列才显示
                        {
                            showFlag = STYLUSDATA_FLAG;

                            changeToDebugMode();

                            textGridLayout.removeAllViews();

                            textGridLayout.setColumnCount(rownum + 1);  //列数=感应数
                            textGridLayout.setRowCount(colnum + 1); //行数=驱动数

                            showAddressHigh = (byte) 0xDD;
                            showAddressLow = (byte) 0x58;

                            if (count == 1000) {
                                tvDataContent.setText("[" + getResources().getString(R.string.stylusdata) + "]");
                                showRawdata();
                            }
                        }
                        break;

                    default:
                        break;
                }//switch (view.getId())
            }//default
            break;
        }
    }

    @Override
    protected void onDestroy() {

        super.onDestroy();

        if (mUsbDeviceConnection != null) {
            mUsbDeviceConnection.releaseInterface(mUsbInterface);
            mUsbDeviceConnection.close();
            mUsbDeviceConnection = null;
        }
        mUsbEndpointIn = null;
        mUsbEndpointOut = null;
        isReceiverMessage = false;
        isNeedFindDevice = false;
        mThreadPool.shutdownNow();
        // unregisterReceiver(mUsbDetachedReceiver);
        unregisterReceiver(daOpenDevicesReceiver);
    }

    //第一次点击事件发生的时间
    //private long mExitTime;

    /**
     * 点击两次返回退出app
     */
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK) {
            /*
            if ((System.currentTimeMillis() - mExitTime) > 2000) {
                Object mHelperUtils;
                Toast.makeText(this, "再按一次退出APP", Toast.LENGTH_SHORT).show();
                //System.currentTimeMillis()系统当前时间
                mExitTime = System.currentTimeMillis();
            } else {
                finish();
            }

             */
            switch (showFlag){
                case RAWDATA_FLAG:  //GT9 rawdata
                case MANUALDATA_FLAG:  //manualdiff
                case DIFFDATA_1BYTE_FLAG:  //diffdata
                case DIFFDATA_2BYTES_FLAG:  //GT738X rawdata
                case REFFDATA_FLAG:
                case STYLUSDATA_FLAG:  //stylusdata
                    showFlag = STOP_FLAG;

                    btn_RawdataShow.setEnabled(true);
                    btn_DiffdataShow.setEnabled(true);
                    btn_ReffdataShow.setEnabled(true);
                    btn_ManualdiffdataShow.setEnabled(true);
                    btn_Manualreff.setEnabled(false);
                    //btn_StylusDataShow.setEnabled(true);

                    break;

                case STOP_FLAG:  //stop
                default:
                    finish();
                    break;
            }
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        switch (requestCode) {
            case 1:
                String filePath;// = Environment.getExternalStorageDirectory() + "/saveconfig/";
                String fileName;
                String temp_string;
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    //创建文件夹
                    if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {

                        StringBuilder configBuilder = new StringBuilder("");

                        //2.save Chanel Number
                        configBuilder.append("[Chanel Number]\n");
                        configBuilder.append("SensorNum:" + edt_RowNum.getText() + "\n");
                        configBuilder.append("DriverNum:" + edt_ColNum.getText() + "\n\n");

                        //3.save test result
                        configBuilder.append("[Test Result]\n");

                        temp_string = "Pass";

                        filePath = Environment.getExternalStorageDirectory() + "/test_result/";
                        //File file = new File(filePath);

                        temp_string = "GT";
                        String hv = "";
                        iicRead32Bits((byte)0x01, (byte)0x00, (byte)0x14,(byte)0x0f, mBytes, 23);

                        for (int i = 10; i < 15; i++)  //Get PID
                        {
                            if (mBytes[i] == 0)
                                break;

                            int v = (mBytes[i] - 48) & 0xFF;  //ASCII码减去48
                            hv = Integer.toHexString(v);
                            temp_string += hv;
                        }

                        if (temp_string.length() < 6)
                        {
                            temp_string = "Null";
                        } else{

                            temp_string += "_";

                            for (int i = 18; i < 22; i++)  //Get version
                            {
                                int v = mBytes[i] & 0xFF;
                                hv = Integer.toHexString(v);
                                if (hv.length() < 2){
                                    hv = "0" + hv;
                                }

                                temp_string += hv;

                                if (i < 21)
                                {
                                    temp_string += ".";
                                }
                            }
                        }
                        temp_string += edt_RowNum.getText() + "x" + edt_ColNum.getText() + "_";

                        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd-HH-mm-ss");
                        Date date = new Date(System.currentTimeMillis());  //获取当前系统时间

                        fileName = temp_string + simpleDateFormat.format(date) + ".csv";//editname.getText().toString();
                        writeTxtToFile(configBuilder.toString().trim(), filePath, fileName);

                        //mShow.setText(fileName + getResources().getString(R.string.saveto) + filePath.toString());

                    }
                }
                break;
            case 2:
                if (grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    //创建文件夹
                    if (Environment.getExternalStorageState().equals(Environment.MEDIA_MOUNTED)) {

                    }
                }
                break;

            case 3:
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED){
                    //权限已成功申请
                }else{
                    //用户拒绝授权
                    Toast.makeText(this,getResources().getString(R.string.nopermission), Toast.LENGTH_SHORT).show();
                    finish();
                }
                break;
            default:
                super.onRequestPermissionsResult(requestCode, permissions, grantResults);
                break;
        }
    }
    // 将字符串写入到文本文件中
    public void writeTxtToFile(String strcontent, String filePath, String fileName) {
        // 生成文件夹之后，再生成文件，不然会出错
        makeFilePath(filePath, fileName);

        String strFilePath = filePath + fileName;
        // 每次写入时，都换行写
        String strContent = strcontent + "\r\n";
        try {
            File file = new File(strFilePath);
            if (!file.exists()) {
                Log.d("TestFile", "Create the file:" + strFilePath);
                file.getParentFile().mkdirs();
                file.createNewFile();
            }
            RandomAccessFile raf = new RandomAccessFile(file, "rwd");
            raf.seek(file.length());
            raf.write(strContent.getBytes());
            raf.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    // 生成文件
    public File makeFilePath(String filePath, String fileName) {
        File file = null;
        makeRootDirectory(filePath);
        try {
            file = new File(filePath + fileName);
            if (!file.exists()) {
                file.createNewFile();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return file;
    }

    // 生成文件夹
    public static void makeRootDirectory(String filePath) {
        File file = null;
        try {
            file = new File(filePath);
            if (!file.exists()) {
                file.mkdir();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
